
// constant
let x: Int = 5
//x += 1

// variable
var y: Int = 6
y += 2

struct S {
    var no = 1
}

class C {
    var str = "hello"
}

// value type
var a = S()
var b = a
b.no += 3
b
a

// reference type
var c = C()
var d = c
d.str = "Hello, world!"
d
c

// value types of value types have value semantics

// major standard library types (array, set, dictionary) follow value semantics
let m: [Int] = [1, 2, 3]
var n = m
n.append(4)
n
m

class Object : NonObjectiveCBase {
    var str = "hello"
    
    func copy() -> Object {
        let cp = Object()
        cp.str = str
        return cp
    }
}

// performance optimization
struct MyWrapper {
    var _object: Object
    var objectForWriting: Object {
        mutating get {
            if !isUniquelyReferenced(&_object) {
                _object = _object.copy()
            }
            return _object
        }
    }
}

var e = MyWrapper(_object: Object())
var f = e
e._object === f._object
f.objectForWriting.str = "something"
e._object === f._object
e
f

// see WWDC 2015 Session 414 for more
























extension S : CustomStringConvertible {
    var description: String {
        return "\(no)"
    }
}

extension C : CustomStringConvertible {
    var description: String {
        return "\(str)"
    }
}

extension Object : CustomStringConvertible {
    var description: String {
        return "\(str)"
    }
}

extension MyWrapper : CustomStringConvertible {
    var description: String {
        return "\(_object)"
    }
}
