
// reference types

// function

func add(i: Int, _ j: Int) -> Int {
    return i + j
}

add(2,3)

// closure

func makeAdder() -> () -> Int {
    var i = 0
    func adder() -> Int {
        i += 1
        return i
    }
    return adder
}

let adder = makeAdder()
adder()
adder()

let anotherAdder = makeAdder()
anotherAdder()

// first class functions
// closure expression

let alsoAdd = {
    (i: Int, j: Int) -> Int in
    return i + j
}

alsoAdd(2, 3)

// higher order functions
// map, reduce, filter, flat map

func foo (a: Int, _ b: Int, closure: (Int, Int) -> Int) -> Int {
    return closure(a, b)
}

foo(5, 6, closure: {
    (x:Int, y: Int) -> Int in
    return x + y
})

foo(5, 6) {
    (x:Int, y: Int) -> Int in
    return x + y
}

foo(5, 6) {
    (x:Int, y: Int) -> Int in
    x + y
}

foo(5, 6) {
    x, y in
    x + y
}

foo(5, 6) {
    $0 + $1
}

foo(5, 6) {
    x, y in
    x
}

//foo(5, 6) {
//    $0
//}

foo(5, 6, closure: +)
