//
//  main.m
//  Classes
//
//  Created by Jiri Dutkevic on 03/03/16.
//  Copyright © 2016 Avast. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <objc/runtime.h>

//@interface Product : NSObject
//
//@property (strong, nonatomic, readonly) NSString *name;
//
//- (instancetype)initWithName:(NSString *)name;
//
//@end

int main(int argc, const char * argv[]) {
    @autoreleasepool {
        
        Class c = objc_allocateClassPair([NSObject class], "Product", 0);
        class_addIvar(c, "name", sizeof(id), log2(sizeof(id)), @encode(id));
        
        Ivar nameIvar = class_getInstanceVariable(c, "name");
        
        IMP initIMP=imp_implementationWithBlock(^(id self, NSString *name) {
            object_setIvar(self, nameIvar, name);
            return self;
        });
        const char *initTypes = [[NSString stringWithFormat:@"%s%s%s%s", @encode(id), @encode(id), @encode(SEL), @encode(id)] UTF8String];
        class_addMethod(c, @selector(initWithName:),
                        initIMP, initTypes);
        
        IMP nameIMP = imp_implementationWithBlock(^(id self) {
            return object_getIvar(self, nameIvar);
        });
        const char *nameTypes = [[NSString stringWithFormat:@"%s%s%s",@encode(id), @encode(id), @encode(SEL)] UTF8String];
        class_addMethod(c, @selector(name), nameIMP, nameTypes);
        
        objc_registerClassPair(c);
        
        id p = [[c alloc] initWithName:@"iPhone"];
        NSLog(@"%@", [p performSelector:@selector(name)]);
        
    }
    return 0;
}
