//
//  KeychainProxy.h
//  Keychain
//
//  Created by Jiri Dutkevic on 17/06/15.
//  Copyright (c) 2015 Avast. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface KeychainProxy : NSObject

- (nullable NSData *)getData:(nonnull NSString *)itemId;

- (BOOL)setData:(nullable NSData *)dt
        forItem:(nonnull NSString *)itemId;

- (nullable NSString *)getString:(nonnull NSString *)itemId;

- (BOOL)setString:(nullable NSString *)str
          forItem:(nonnull NSString *)itemId;

- (BOOL)isItemPresent:(nonnull NSString *)itemId;

- (BOOL)deleteItem:(nonnull NSString *)itemId;

- (BOOL)addData:(nonnull NSData *)dt
        forItem:(nonnull NSString *)itemId
withSecurityAttribute:(nonnull CFStringRef)secAttr;

- (BOOL)updateData:(nonnull NSData *)dt
           forItem:(nonnull NSString *)itemId
withSecurityAttribute:(nonnull CFStringRef)secAttr;

- (BOOL)addString:(nonnull NSString *)str
          forItem:(nonnull NSString *)itemId
withSecurityAttribute:(nonnull CFStringRef)secAttr;

- (BOOL)updateString:(nonnull NSString *)str
             forItem:(nonnull NSString *)itemId
withSecurityAttribute:(nonnull CFStringRef)secAttr;

@end
